unit BmpData;

interface

uses
  Graphics;

procedure MonoDataToBitmap(var Bitmap: TBitmap; DataArray: array of Word);

const
  GmarkBitmapData: array[0..100] of Word = (24, 66,
    $0006, $0000, $0F00, $001F, $0000, $1F00, $003F, $8000, $3F80, $0038,
    $8000, $3080, $0070, $4000, $6040, $0060, $4000, $60C0, $0040, $C000,
    $40C0, $0041, $C000, $41C0, $0043, $8000, $4780, $004F, $8000, $3F00,
    $003F, $0000, $7E00, $00FE, $0001, $FC00, $03F8, $0007, $F000, $0FF0,
    $000F, $D800, $1F88, $003F, $0800, $3E08, $007C, $1F80, $7C3F, $F078,
    $3FF8, $F07F, $FCF0, $FFFE, $E0FC, $FEE1, $E63E, $E1C6, $1FE1, $C20F,
    $E182, $07E1, $8307, $E183, $0760, $8107, $3041, $0610, $310E, $1801,
    $8C0C, $0198, $0600, $B001, $80C0, $007F, $8000, $00C0, $0000, $C000,
    $0040, $0000, $4000, $0040, $00E0, $6003, $F060, $03F0, $2007, $F820,
    $07F8, $6007, $F040, $03F0, $4003, $8080, $01C3, $0000, $7C00);
  FmarkBitmapData: array[0..52] of Word = (26, 31,
    $01FC, $0001, $C7C0, $0080, $7800, $400F, $0620, $03E3, $D800, $7CF7,
    $F01F, $19FE, $07C0, $7F81, $F81F, $E07E, $03F8, $1F80, $7C07, $C000,
    $01F1, $8000, $7CF0, $001F, $3C00, $0F86, $0003, $E000, $01F0, $0000,
    $FC00, $003E, $0000, $1F00, $0007, $8000, $03C0, $0001, $E000, $00F0,
    $0000, $F000, $0070, $0000, $3800, $003C, $0000, $1C00, $0008, $0000,
    $0000);
  FourBitmapData: array[0..15] of Word = (12, 18,
    $00C0, $1C03, $C03C, $07C0, $BC13, $C13C, $23C4, $3C83, $CFFF, $FFFF,
    $FF03, $C03C, $03C0, $3C00);
  FigureBitmapData: array[0..39] of Word = (60, 10,
    $7BC3, $8E08, $F1FE, $79EC, $CC7D, $F19E, $33EC, $F3CC, $CCE3, $1906,
    $02CF, $3CCC, $0C23, $9CF8, $4EB3, $CCC0, $8C5B, $ECC4, $733C, $CC08,
    $7587, $CC43, $B3CC, $C103, $981C, $C85D, $ECCC, $203F, $C1CC, $8CC6,
    $CCC7, $F21B, $2CC8, $CCC7, $BFFF, $C1BC, $7887, $B000);

implementation

procedure MonoDataToBitmap(var Bitmap: TBitmap; DataArray: array of Word);
var
 Data: Word;
 DataIndex: Longint;
 Bit: Integer;
 x, y: Integer;
begin
 with Bitmap do
  begin
   Width  := DataArray[0];
   Height := DataArray[1];
   DataIndex := 2;
   Bit := 0;
   Data := DataArray[2];
   for y := 0 to Height - 1 do
    for x := 0 to Width - 1 do
     begin
      if $8000 = Data and $8000 then
       Canvas.Pixels[x, y] := clBlack
      else
       Canvas.Pixels[x, y] := clWhite;
      Data := Data shl 1;
      Bit := Bit + 1;
      if 16 = Bit then
       begin
        DataIndex := DataIndex + 1;
        Data := DataArray[DataIndex];
        Bit := 0;
       end;
     end;
  end;
end;

end.
