unit CnvsSizD;

interface

uses
  Classes, Controls, Forms, StdCtrls, SysUtils, WinProcs, WinTypes;

type
  TCanvasSizeDialog = class(TForm)
    WidthLabel: TLabel;
    WidthEdit: TEdit;
    HeightLabel: TLabel;
    HeightEdit: TEdit;
    OkButton: TButton;
    CancelButton: TButton;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  protected
{    function GetBitmapHeight: Longint;}
    function GetBitmapWidth: Longint;
{    procedure SetBitmapHeight(AHeight: Longint);}
    procedure SetBitmapWidth(AWidth: Longint);
  public
{    property BitmapHeight: Longint read GetBitmapHeight write SetBitmapHeight;}
    property BitmapWidth: Longint read GetBitmapWidth write SetBitmapWidth;
    function Execute: Boolean;
  end;

var
  CanvasSizeDialog: TCanvasSizeDialog;

implementation

{$R *.DFM}

procedure TCanvasSizeDialog.FormShow(Sender: TObject);
begin
 ActiveControl := WidthEdit;
 WidthEdit.SelectAll;
end;

procedure TCanvasSizeDialog.FormClose(Sender: TObject;
  var Action: TCloseAction);
var
 w: Integer;
begin
 if mrOk = ModalResult then
  try
   w := StrToInt(WidthEdit.Text);
   WidthEdit.Text := IntToStr(w);
   if w < 1 then
    begin
     ModalResult := mrNone;
     Action := caNone;
     ActiveControl := WidthEdit;
     WidthEdit.SelectAll;
     MessageBeep(MB_ICONHAND);
     Exit;
    end;
   Action := caHide;
  except
   on EConvertError do
    begin
     ModalResult := mrNone;
     Action := caNone;
     ActiveControl := WidthEdit;
     WidthEdit.SelectAll;
     MessageBeep(MB_ICONHAND);
    end;
  end;
end;

{function TCanvasSizeDialog.GetBitmapHeight: Longint;
begin
 Result := StrToInt(HeightEdit.Text);
end;}

function TCanvasSizeDialog.GetBitmapWidth: Longint;
begin
 Result := StrToInt(WidthEdit.Text);
end;

{procedure TCanvasSizeDialog.SetBitmapHeight(AHeight: Longint);
begin
 HeightEdit.Text := IntToStr(AHeight);
end;}

procedure TCanvasSizeDialog.SetBitmapWidth(AWidth: Longint);
begin
 WidthEdit.Text := IntToStr(AWidth);
end;

function TCanvasSizeDialog.Execute: Boolean;
begin
 Result := mrOk = ShowModal;
end;

end.
