unit NoteLenD;

interface

uses
  Forms, StdCtrls, Classes, Controls, ExtCtrls;

type
  TNoteLengthDialog = class(TForm)
    NoteLengthRadioGroup: TRadioGroup;
    OkButton: TButton;
    CancelButton: TButton;
    procedure FormShow(Sender: TObject);
  protected
    function GetNoteLength: Integer;
    procedure SetNoteLength(ALength: Integer);
  public
    property NoteLength: Integer read GetNoteLength write SetNoteLength;
    function Execute: Boolean;
    function NoteLengthIndex: Integer;
    function NoteLengthString: String;
  end;

var
  NoteLengthDialog: TNoteLengthDialog;

implementation

{$R *.DFM}

procedure TNoteLengthDialog.FormShow(Sender: TObject);
begin
 ActiveControl := NoteLengthRadioGroup;
end;

function TNoteLengthDialog.GetNoteLength: Integer;
begin
 Result := NoteLengthRadioGroup.ItemIndex + 1;
end;

procedure TNoteLengthDialog.SetNoteLength(ALength: Integer);
begin
 NoteLengthRadioGroup.ItemIndex := ALength - 1;
end;

function TNoteLengthDialog.Execute: Boolean;
begin
 Result := mrOk = ShowModal;
end;

function TNoteLengthDialog.NoteLengthIndex: Integer;
var
 Index, i: Integer;
begin
 Index := 1;
 if NoteLength in [1, 2, 4, 8, 16, 32, 64] then
  for i := 1 to 7 do
   if Index = NoteLength then
    begin
     Result := i;
     Break;
    end
   else
    Index := Index * 2
 else
  Result := 0;
end;

function TNoteLengthDialog.NoteLengthString: String;
begin
 Result := NoteLengthRadioGroup.Items[NoteLength - 1];
end;

end.
