unit TempoD;

interface

uses
  Classes, Controls, Forms, StdCtrls, SysUtils, WinProcs, WinTypes;

type
  TTempoSetDialog = class(TForm)
    TempoLabel: TLabel;
    TempoEdit: TEdit;
    OkButton: TButton;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  public
    function Execute(ATempo: Integer): Integer;
  end;

var
  TempoSetDialog: TTempoSetDialog;

implementation

{$R *.DFM}

procedure TTempoSetDialog.FormShow(Sender: TObject);
begin
 ActiveControl := TempoEdit;
 TempoEdit.SelectAll;
end;

procedure TTempoSetDialog.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
 try
  if StrToInt(TempoEdit.Text) < 1 then
   begin
    ModalResult := mrNone;
    Action := caNone;
    ActiveControl := TempoEdit;
    TempoEdit.SelectAll;
    MessageBeep(MB_ICONHAND);
    Exit;
   end;
  Action := caHide;
 except
  on EConvertError do
   begin
    ModalResult := mrNone;
    Action := caNone;
    ActiveControl := TempoEdit;
    TempoEdit.SelectAll;
    MessageBeep(MB_ICONHAND);
   end;
 end;
end;

function TTempoSetDialog.Execute(ATempo: Integer): Integer;
begin
 TempoEdit.Text := IntToStr(ATempo);
 ShowModal;
 Result := StrToInt(TempoEdit.Text);
end;

end.
